#pragma once

#include <commctrl.h>

#include <string>
#include <list>

#include "BeckyApi.h"
#include "AddressInfo.h"
#include "BkBsfilWrapper.h"
#include "BkBsfilProfile.h"

////////////////////////////////////////////////////////////////////////
// ݒ_CAOւ̃p[^
////////////////////////////////////////////////////////////////////////

class SettingDialogParam {
public:
	// Becky! API ւ̎Q
	CBeckyAPI* pbka;
	// Becky! ̃f[^tH_
	std::string bkaDataFolder;
	// vOC̃f[^tH_
	std::string dataFolder;
	// bsfilter ̐ݒt@C
	std::string bsfilterConfig;
	// bsfilter ̃f[^x[XtH_
	std::string dbFolder;
	// BkBsfilWrapper ̐ݒ
	BkBsfilProfile bkProfile;
	// BkBsfilWrapper ̐ݒ(p)
	BkBsfilProfileEnv bkProfileEnv;
	// zCgXg
	WhiteList whiteList;
	// f[^x[X̔rp
	CRITICAL_SECTION* pcsDatabase;
};

////////////////////////////////////////////////////////////////////////
// BkBsfilWrapper ̐ݒs_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

class CBkBsfilSettingDialogProc {
public:
	// RXgN^
	CBkBsfilSettingDialogProc(SettingDialogParam& param);

public:
	// BkBsfilWrapper ̐ݒs_CAOvV[W
	BOOL DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	// WM_INITDIALOG nh
	BOOL OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam);
	// WM_COMMAND nh
	void OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify);
	// WM_NOTIFY nh
	BOOL OnNotify(HWND hWnd, int idCtl, NMHDR* pnmhdr);

private:
	// bsfilter f[^x[XobNAbv
	bool BackupBsfilterResource(char* backupFilepath, std::list<std::string>& fileList);
	// bsfilter f[^x[XXgA
	bool RestoreBsfilterResource(const char* backupFilepath, std::list<std::string>& fileList);

private:
	// ݒ_CAOւ̃p[^
	SettingDialogParam& m_param;
	// _CAÕLvV
	char m_dlgCaption[1024];
};

////////////////////////////////////////////////////////////////////////
// zCgXg̐ݒs_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

class CWhiteListDialogProc {
public:
	// RXgN^
	CWhiteListDialogProc(SettingDialogParam& param);
	// fXgN^
	virtual ~CWhiteListDialogProc();

public:
	// zCgXg̐ݒs_CAOvV[W
	BOOL DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	// WM_INITDIALOG nh
	BOOL OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam);
	// WM_COMMAND nh
	void OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify);
	// WM_NOTIFY nh
	BOOL OnNotify(HWND hWnd, int idCtl, NMHDR* pnmhdr);

private:
	// [[AhXꗗɒǉ
	void AddMail(HWND hWnd, const char* email, const char* note);
	// [AhXꗗ̃[XV
	void UpdateMail(HWND hWnd, const char* email, const char* note);
	// [AhXꗗ烁[폜
	void DeleteMail(HWND hWnd);
	// [AhXꗗ̃^Cgɖݒ肷
	void SetAddrListSortArrow(HWND listCtrl);

private:
	// ݒ_CAOւ̃p[^
	SettingDialogParam& m_param;
	// _CAÕLvV
	char m_dlgCaption[1024];
	// AhXꗗpC[WXg
	HIMAGELIST m_hImgList;
	// \[g̖̃rbg}bv
	HBITMAP m_bmUpArrow;
	HBITMAP m_bmDownArrow;
};

////////////////////////////////////////////////////////////////////////
// ȗṽ_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

class COtherDialogProc {
public:
	// RXgN^
	COtherDialogProc(SettingDialogParam& param);

public:
	// ȗṽ_CAOvV[W
	BOOL DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	// WM_INITDIALOG nh
	BOOL OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam);
	// WM_NOTIFY nh
	BOOL OnNotify(HWND hWnd, int idCtl, NMHDR* pnmhdr);

private:
	// ݒ_CAOւ̃p[^
	SettingDialogParam& m_param;
	// _CAÕLvV
	char m_dlgCaption[1024];
};

////////////////////////////////////////////////////////////////////////
// ݒ_CAO
////////////////////////////////////////////////////////////////////////

class CSettingDialog
{
public:
	// RXgN^
	CSettingDialog(SettingDialogParam& param);

private:
	// BkBsfilWrapper ̐ݒs_CAOvV[W
	static BOOL CALLBACK BkBsfilSettingDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	// zCgXg̐ݒs_CAOvV[W
	static BOOL CALLBACK WhiteListDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	// ȗṽ_CAOvV[W
	static BOOL CALLBACK OtherDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

public:
	// \
	int DoModal(HWND hWndParent);

private:
	// ݒ_CAOւ̃p[^
	SettingDialogParam& m_param;
	// BkBsfilWrapper ̐ݒs_CAOvV[W̋@\
	CBkBsfilSettingDialogProc m_bkBsfilSettingDialogProc;
	// zCgXg̐ݒs_CAOvV[W̋@\
	CWhiteListDialogProc m_whiteListDialogProc;
	// ȗṽ_CAOvV[W̋@\
	COtherDialogProc m_otherDialogProc;

private:
	// g̃CX^X
	static CSettingDialog* s_pThis;
};
